//+------------------------------------------------------------------+
//|                                       AA_THREE_LINE_IND_TEST.mq4 |
//|                                             tradertobe@gmail.com |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "more"
#property link      "more"
//*****************************************************************************
#include <ChanExpertImport.mq4>
//*****************************************************************************
extern bool   ExpertEnable    = true;
extern int    HostExpertMagic = 20;            // It's youor's ExpertMagic
extern string PeerName        = "Tradertobe";  // It's me...
extern int    PeerExpertMagic = 10;            // It's my ExpertMagic
       int    WaitForReplyTimeout = 10 ;       // in seconds, do not tuch...
       string Comm            = "REMOTE_IND_TEST";  
//*****************************************************************************
string Indicator_Name = "THREE_LINE_IND_TEST: ";
//----
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_color2 White
#property indicator_color3 White
double UpperBuffer[];
double MovingBuffer[];
double LowerBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MovingBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,UpperBuffer);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,LowerBuffer);
   return(0);
  }
//----
string  symbol = "1234567890";
int     timeframe[1];
#define barscount  300
double  IndBuf_Recieved[barscount];
int     Ticket = 0;
int     Ret;
int     i,j,k,Counted_bars;
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
    Comment(" ");
    Ret = ChanClose(Ticket);
    if (!Ret) 
    {
         Print("ChanGetLastUSERError = " ,ChanGetLastUSERError(),"  ChanGetLastWSAError = " ,ChanGetLastWSAError());    
         Print("ChanClose(Ticket) failed");
    }
    else
         Print("ChanClose(Ticket) OK! ");
    Ticket = 0;     
    Ret = ChanExpertDeInit(HostExpertMagic);
    if (!Ret) 
    {
         Print("ChanGetLastUSERError = " ,ChanGetLastUSERError(),"  ChanGetLastWSAError = " ,ChanGetLastWSAError());    
         Print("ChanExpertDeInit(HostExpertMagic) failed");
    }
    else
         Print("ChanExpertDeInit(HostExpertMagic) OK! ");
    return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()                          
{
    if (!ExpertEnable) return;
    symbol = Symbol();
    timeframe[0] = Period();
    double Dummy[1];
    if (Ticket == 0)
    {
         Ret = ChanExpertStartup(
              HostName,
              WaitForReplyTimeout
              );
         if (!Ret) 
         {
              Print("ChanGetLastUSERError = " ,ChanGetLastUSERError(),"  ChanGetLastWSAError = " ,ChanGetLastWSAError());    
              Print("ChanExpertStartup failed. Expert stopped.");
              ExpertEnable = false; return;
         }
         else
              Print("ChanExpertStartup OK! ");
         Ret = ChanExpertInit(HostExpertMagic);
         if (!Ret) 
         {
              Comment("ChanExpertInit(HostExpertMagic) failed"+"\n"+
                      "ChanGetLastUSERError = " ,ChanGetLastUSERError(),"  ChanGetLastWSAError = " ,ChanGetLastWSAError());    
              ExpertEnable = false; return;
         }
         else
              Comment("ChanExpertInit(HostExpertMagic) OK!");
         Ret = ChanOpen(PeerName, PeerExpertMagic, HostExpertMagic, symbol,timeframe,1,Dummy,1);      
         if (!Ret)
         {
              Print("ChanOpen(...) failed. Expert stopped.");
              Print("ChanGetLastUSERError = " ,ChanGetLastUSERError(),"  ChanGetLastWSAError = " ,ChanGetLastWSAError());    
              ExpertEnable = false; return;
         }
         else
         {
              Ticket = Ret;
              Print("ChanOpen(...) OK! ");
         }
         return;
    } // if (Ticket == 0)
    Ret = 1;
    while (Ret > 0)
    {
        Ret = ChanReciveDouble(Ticket,IndBuf_Recieved,barscount);
        Comment("ChanReciveDouble(Ticket,IndBuf_0_Recieved,barscount) OK. RecvBytes = ",Ret);
        if (Ret < 0)
        {
             if (ChanGetLastUSERError() == IN_OUT_CONTEXT_BUSY)
             {
                  Comment("ChanReciveDouble(Ticket,IndBuf_0_Recieved,barscount): ChanGetLastUSERError() == IN_OUT_CONTEXT_BUSY");  
                  return;
             }
             Comment("ChanReciveDouble(Ticket,IndBuf_0_Recieved,barscount) failed. Expert stopped."+"\n"+
                     "ChanGetLastUSERError = " ,ChanGetLastUSERError(),"  ChanGetLastWSAError = " ,ChanGetLastWSAError());    
             ExpertEnable = false; return;
        }
    }
    Comment("ChanReciveDouble(Ticket,IndBuf_0_Recieved,barscount) OK. RecvBytes = ",Ret);
//    if (Ret == 0) return;
//--------------------------------------------------------------------
    Counted_bars = IndicatorCounted(); //    
    i = Bars - Counted_bars - 1;       //   
    if (i > barscount/3-1)  i = barscount/3-1; //       
//-----------------------------------------------------------------------  
    int k = 0;
    for (i = barscount/3-1; i >= 0; i--)
    {
         UpperBuffer [i] = IndBuf_Recieved[barscount-1-0-k];
         MovingBuffer[i] = IndBuf_Recieved[barscount-1-1-k];
         LowerBuffer [i] = IndBuf_Recieved[barscount-1-2-k] ;
         k +=3;
    } // for (i = barscount-1; i >= 0; i--) {   
    return;                          
  } // end of int start()
//--------------------------------------------------------------------

